<?php
/**
 * Aliases for special pages of CentralNotice extension.
 */

$specialPageAliases = [];

/** English (English) */
$specialPageAliases['en'] = [
	'CentralNotice' => [ 'CentralNotice' ],
	'CentralNoticeBanners' => [ 'CentralNoticeBanners' ],
	'CentralNoticeLogs' => [ 'CentralNoticeLogs' ],
	'NoticeTemplate' => [ 'NoticeTemplate' ],
	'BannerAllocation' => [ 'BannerAllocation' ],
	'BannerController' => [ 'BannerController' ],
	'BannerLoader' => [ 'BannerLoader' ],
	'BannerRandom' => [ 'BannerRandom' ],
	'RecordImpression' => [ 'RecordImpression' ],
	'HideBanners' => [ 'HideBanners' ],
];

/** Arabic (العربية) */
$specialPageAliases['ar'] = [
	'CentralNotice' => [ 'ملاحظة_مركزية' ],
	'CentralNoticeBanners' => [ 'إعلانات_الملاحظة_المركزية' ],
	'CentralNoticeLogs' => [ 'سجلات_الملاحظة_المركزية' ],
	'NoticeTemplate' => [ 'قالب_الملاحظة' ],
	'GlobalAllocation' => [ 'تخصيص_عام' ],
	'BannerAllocation' => [ 'وضع_الإعلان' ],
	'BannerController' => [ 'متحكم_الإعلان' ],
	'BannerLoader' => [ 'محمل_الإعلان' ],
	'BannerRandom' => [ 'إعلان_عشوائي' ],
	'RecordImpression' => [ 'تسجيل_الانطباع' ],
	'HideBanners' => [ 'إخفاء_الإعلان' ],
];

/** Egyptian Arabic (مصرى) */
$specialPageAliases['arz'] = [
	'CentralNotice' => [ 'ملاحظة_مركزية' ],
	'CentralNoticeBanners' => [ 'اعلانات_النوتيس_المركزيه' ],
	'CentralNoticeLogs' => [ 'سجلات_النوتيس_المركزيه' ],
	'NoticeTemplate' => [ 'قالب_الملاحظة' ],
	'GlobalAllocation' => [ 'تخصيص_عمومى' ],
	'BannerAllocation' => [ 'وضع_البانر' ],
	'BannerController' => [ 'متحكم_فى_البانر' ],
	'BannerLoader' => [ 'محمل_البانر' ],
	'BannerRandom' => [ 'بانر_عشوائى' ],
	'RecordImpression' => [ 'تسجيل_الانطباع' ],
	'HideBanners' => [ 'تخبيه-البانر' ],
];

/** Assamese (অসমীয়া) */
$specialPageAliases['as'] = [
	'CentralNotice' => [ 'কেন্দ্ৰীয়_জাননী' ],
	'CentralNoticeLogs' => [ 'কেন্দ্ৰীয়_জাননী_অভিলেখসমূহ' ],
	'NoticeTemplate' => [ 'জাননী_সাঁচ' ],
];

/** Western Balochi (بلوچی رخشانی) */
$specialPageAliases['bgn'] = [
	'CentralNotice' => [ 'مرکزین_جار_یا_ئیلان' ],
	'CentralNoticeBanners' => [ 'مرکزین_ئیلانی_بیراک_ئان' ],
	'CentralNoticeLogs' => [ 'مرکزین_ئیلانی_سیاهه_ئان' ],
	'NoticeTemplate' => [ 'ئیلامیه_ئی_تراشوان' ],
	'GlobalAllocation' => [ 'سراسرین_تخسیس' ],
	'BannerAllocation' => [ 'نشانی_جاگه' ],
	'BannerController' => [ 'نشانی_کنترول' ],
	'BannerLoader' => [ 'نشانی_بُرز_کورتین' ],
	'BannerRandom' => [ 'تسادوپین_نشان' ],
	'RecordImpression' => [ 'اهساس_ئی_سبت_کورتین' ],
	'HideBanners' => [ 'نشان_ئانی_چیهر_کورتین' ],
];

/** Breton (brezhoneg) */
$specialPageAliases['br'] = [
	'HideBanners' => [ 'KuzhatBanniel' ],
];

/** German (Deutsch) */
$specialPageAliases['de'] = [
	'CentralNotice' => [ 'Zentrale_Mitteilung' ],
	'CentralNoticeBanners' => [ 'Zentrale_Mitteilungsvorlagen' ],
	'CentralNoticeLogs' => [ 'Logbücher_zur_zentralen_Mitteilung' ],
	'NoticeTemplate' => [ 'Mitteilungsvorlage' ],
	'GlobalAllocation' => [ 'Globale_Anordnung' ],
	'BannerAllocation' => [ 'Vorlagenanordnung' ],
	'BannerController' => [ 'Vorlagensteuerung' ],
	'BannerLoader' => [ 'Vorlage_laden' ],
	'BannerRandom' => [ 'Zufällige_Vorlage' ],
	'RecordImpression' => [ 'Zugriffe_zählen' ],
	'HideBanners' => [ 'Vorlagen_ausblenden' ],
];

/** Zazaki (Zazaki) */
$specialPageAliases['diq'] = [
	'CentralNotice' => [ 'MerkezêXeberdaren' ],
	'CentralNoticeBanners' => [ 'MerkezÊTebliğêAfişan' ],
	'CentralNoticeLogs' => [ 'MerkezêİlanêRocekan' ],
	'NoticeTemplate' => [ 'ŞablonêXeberdaren' ],
	'GlobalAllocation' => [ 'TehsisoGlover' ],
	'BannerAllocation' => [ 'TehsisêAfişan' ],
	'BannerController' => [ 'KontrolkarêAfişan' ],
	'BannerLoader' => [ 'BarkerdoğêAfişan' ],
	'BannerRandom' => [ 'AfişoRastameye' ],
	'RecordImpression' => [ 'TepıştekVinayış' ],
	'HideBanners' => [ 'AfişanBınımne' ],
];

/** Esperanto (Esperanto) */
$specialPageAliases['eo'] = [
	'CentralNotice' => [ 'Centra_informilo' ],
	'NoticeTemplate' => [ 'Informŝablono' ],
	'BannerAllocation' => [ 'Strirezervado' ],
	'BannerController' => [ 'Informstrikontrolisto' ],
	'BannerLoader' => [ 'Informstriŝargilo' ],
	'HideBanners' => [ 'Kaŝi_striojn', 'Kaŝu_striojn' ],
];

/** Persian (فارسی) */
$specialPageAliases['fa'] = [
	'CentralNotice' => [ 'اعلان_مرکزی' ],
	'CentralNoticeBanners' => [ 'پرچم‌های_اعلان_مرکزی' ],
	'CentralNoticeLogs' => [ 'سیاهه‌های_اعلان_مرکزی' ],
	'NoticeTemplate' => [ 'الگوی_اعلامیه' ],
	'GlobalAllocation' => [ 'تخصیص_سراسری' ],
	'BannerAllocation' => [ 'موقعیت_نشان' ],
	'BannerController' => [ 'کنترل_نشان' ],
	'BannerLoader' => [ 'بارگیری_نشان' ],
	'BannerRandom' => [ 'نشان_تصادفی' ],
	'RecordImpression' => [ 'ثبت_احساس' ],
	'HideBanners' => [ 'پنهان‌کردن_نشان‌ها' ],
];

/** Galician (galego) */
$specialPageAliases['gl'] = [
	'CentralNotice' => [ 'Aviso_central' ],
	'CentralNoticeBanners' => [ 'Carteis_do_aviso_central' ],
	'CentralNoticeLogs' => [ 'Rexistro_do_aviso_central' ],
	'NoticeTemplate' => [ 'Modelo_de_aviso' ],
];

/** Hebrew (עברית) */
$specialPageAliases['he'] = [
	'CentralNotice' => [ 'הודעה_מרכזית' ],
	'CentralNoticeBanners' => [ 'כרזות_הודעה_מרכזית' ],
	'CentralNoticeLogs' => [ 'יומני_הודעה_מרכזית' ],
	'NoticeTemplate' => [ 'תבנית_הודעה' ],
	'GlobalAllocation' => [ 'הקצאה_גלובלית' ],
	'BannerAllocation' => [ 'הקצאת_כרזה' ],
	'BannerController' => [ 'בקר_כרזה' ],
	'BannerLoader' => [ 'טוען_כרזות' ],
	'BannerRandom' => [ 'כרזה_אקראית' ],
	'RecordImpression' => [ 'תצוגות_שיא' ],
	'HideBanners' => [ 'החבאת_כרזות' ],
];

/** Upper Sorbian (hornjoserbsce) */
$specialPageAliases['hsb'] = [
	'CentralNotice' => [ 'Centralna_zdźělenka' ],
];

/** Xiang Chinese (湘语) */
$specialPageAliases['hsn'] = [
	'CentralNotice' => [ '中心公告' ],
	'NoticeTemplate' => [ '公告样范' ],
	'BannerAllocation' => [ '横幅配置' ],
	'BannerController' => [ '横幅控制器' ],
	'BannerLoader' => [ '横幅载入器' ],
	'HideBanners' => [ '隐藏横幅' ],
];

/** Haitian (Kreyòl ayisyen) */
$specialPageAliases['ht'] = [
	'CentralNotice' => [ 'NòtSantral' ],
	'NoticeTemplate' => [ 'ModèlNòt' ],
	'BannerAllocation' => [ 'BayAnsey' ],
	'BannerController' => [ 'KontroleAnsey' ],
	'BannerLoader' => [ 'ChajeAnsey' ],
];

/** Interlingua (interlingua) */
$specialPageAliases['ia'] = [
	'CentralNotice' => [ 'Aviso_central' ],
	'CentralNoticeLogs' => [ 'Registro_de_aviso_central' ],
	'NoticeTemplate' => [ 'Patrono_de_aviso' ],
	'BannerAllocation' => [ 'Alloca_bandieras' ],
	'BannerController' => [ 'Controla_bandieras' ],
	'BannerLoader' => [ 'Carga_bandieras' ],
	'HideBanners' => [ 'Celar_bandieras' ],
];

/** Italian (italiano) */
$specialPageAliases['it'] = [
	'CentralNotice' => [ 'AvvisoCentralizzato' ],
	'CentralNoticeLogs' => [ 'RegistriAvvisoCentralizzato' ],
	'NoticeTemplate' => [ 'TemplateAvviso' ],
	'BannerAllocation' => [ 'DestinazioneBanner' ],
	'BannerController' => [ 'ControllerBanner' ],
	'BannerLoader' => [ 'CaricatoreBanner' ],
	'HideBanners' => [ 'NascondiBanner' ],
];

/** Japanese (日本語) */
$specialPageAliases['ja'] = [
	'CentralNotice' => [ '中央管理通知' ],
	'CentralNoticeBanners' => [ '中央管理通知バナー' ],
	'CentralNoticeLogs' => [ '中央管理通知記録' ],
	'NoticeTemplate' => [ '通知テンプレート' ],
	'GlobalAllocation' => [ 'グローバル割り当て' ],
	'BannerAllocation' => [ 'バナー割り当て' ],
	'BannerController' => [ 'バナー制御' ],
	'BannerLoader' => [ 'バナー読み込み' ],
	'BannerRandom' => [ 'バナーおまかせ', 'バナーランダム' ],
	'HideBanners' => [ 'バナー非表示', 'バナーを隠す' ],
];

/** Georgian (ქართული) */
$specialPageAliases['ka'] = [
	'HideBanners' => [ 'ბანერების_დამალვა' ],
];

/** Korean (한국어) */
$specialPageAliases['ko'] = [
	'CentralNotice' => [ '중앙공지' ],
	'CentralNoticeBanners' => [ '중앙공지배너' ],
	'CentralNoticeLogs' => [ '중앙공지기록' ],
	'NoticeTemplate' => [ '알림틀', '공지틀' ],
	'GlobalAllocation' => [ '전역할당' ],
	'BannerAllocation' => [ '배너배정' ],
	'BannerController' => [ '배너컨트롤러' ],
	'BannerLoader' => [ '배너열기', '배너로더' ],
	'BannerRandom' => [ '배너임의' ],
	'RecordImpression' => [ '기록노출' ],
	'HideBanners' => [ '배너숨기기' ],
];

/** Cornish (kernowek) */
$specialPageAliases['kw'] = [
	'CentralNotice' => [ 'ArgemmynKres' ],
	'CentralNoticeLogs' => [ 'KovnotennowArgemynnowKres' ],
	'NoticeTemplate' => [ 'SkantlynArgemynnow' ],
	'HideBanners' => [ 'KudhaBanerow' ],
];

/** Ladino (Ladino) */
$specialPageAliases['lad'] = [
	'CentralNotice' => [ 'AvisoCentral' ],
	'NoticeTemplate' => [ 'Xabblón_de_aviso' ],
];

/** Luxembourgish (Lëtzebuergesch) */
$specialPageAliases['lb'] = [
	'BannerController' => [ 'Bannersteierung' ],
	'BannerRandom' => [ 'Zoufällege_Banner' ],
	'HideBanners' => [ 'Banner_verstoppen' ],
];

/** Northern Luri (لۊری شومالی) */
$specialPageAliases['lrc'] = [
	'CentralNotice' => [ 'ڤیرداری_مینجایی' ],
	'CentralNoticeBanners' => [ 'بئیرأقیا_ڤارئسکار_مینجایی' ],
	'CentralNoticeLogs' => [ 'پئھرئستنوٙمە_یا_ڤارئسکار_مینجایی' ],
	'NoticeTemplate' => [ 'چوٙأ_ڤارئسکار' ],
	'GlobalAllocation' => [ 'گوزینئشت_کاری_جأهوٙنی' ],
	'BannerAllocation' => [ 'گوزینئشت_کاری_بئیرأق' ],
	'BannerController' => [ 'ڤارئسکار_بئیرأق' ],
	'BannerLoader' => [ 'بئیرأق_ڤادار' ],
	'BannerRandom' => [ 'بئیرأق_بأختأکی' ],
	'HideBanners' => [ 'نئھوٙکئردئن_بئیرأقیا' ],
];

/** Malagasy (Malagasy) */
$specialPageAliases['mg'] = [
	'CentralNotice' => [ 'Ivom-pampandrenesana', 'Ivompampandrenesana' ],
	'CentralNoticeBanners' => [ 'Banieran\'ivom-pampandrenesana', 'BanieranIvompampandrenesana' ],
	'CentralNoticeLogs' => [ 'Laogin\'Ivom-pampandrenesana', 'LaoginIvom-pampandrenesana' ],
	'NoticeTemplate' => [ 'EndrikaFampandrenesana' ],
	'GlobalAllocation' => [ 'FanokananaManerantsehatra' ],
	'BannerAllocation' => [ 'FanokananaBaniera' ],
	'BannerController' => [ 'FampifehezanaBaniera' ],
	'HideBanners' => [ 'HanafinaBaniera' ],
];

/** Macedonian (македонски) */
$specialPageAliases['mk'] = [
	'CentralNotice' => [ 'ЦентралноИзвестување' ],
	'CentralNoticeBanners' => [ 'ЦентралноИзвестувањеПлакати' ],
	'CentralNoticeLogs' => [ 'ДневнициНаЦентралноИзвестување' ],
	'NoticeTemplate' => [ 'ШаблонЗаИзвестување' ],
	'GlobalAllocation' => [ 'ГлобалнаРаспределба' ],
	'BannerAllocation' => [ 'РаспределбаНаПлакати' ],
	'BannerController' => [ 'КонтролорНаПлакати' ],
	'BannerLoader' => [ 'ВчитувачНаПлакати' ],
	'BannerRandom' => [ 'ПлакатСлучаен' ],
	'RecordImpression' => [ 'ЗаведиВпечаток' ],
	'HideBanners' => [ 'СкријПлакати' ],
];

/** Malayalam (മലയാളം) */
$specialPageAliases['ml'] = [
	'CentralNotice' => [ 'കേന്ദ്രീകൃതഅറിയിപ്പ്' ],
	'CentralNoticeLogs' => [ 'കേന്ദ്രീകൃതഅറിയിപ്പ്‌രേഖകൾ' ],
	'NoticeTemplate' => [ 'അറിയിപ്പ്ഫലകം' ],
];

/** Norwegian Bokmål (norsk bokmål) */
$specialPageAliases['nb'] = [
	'CentralNotice' => [ 'Sentralnotis' ],
	'CentralNoticeLogs' => [ 'Sentralnotislogger' ],
	'NoticeTemplate' => [ 'Notismal' ],
	'BannerAllocation' => [ 'Bannerplassering' ],
	'BannerController' => [ 'Bannerkontroll' ],
	'BannerLoader' => [ 'Bannerlaster' ],
	'HideBanners' => [ 'Skjul_bannere' ],
];

/** Low Saxon (Netherlands) (Nedersaksies) */
$specialPageAliases['nds-nl'] = [
	'CentralNotice' => [ 'Sentrale_mededeling' ],
	'CentralNoticeLogs' => [ 'Sentrale_mededelingenlogboek' ],
	'NoticeTemplate' => [ 'Mededelingsmal' ],
	'GlobalAllocation' => [ 'Globale_toewiezing' ],
	'BannerAllocation' => [ 'Baniertoewiezing' ],
	'BannerController' => [ 'Banierbeheerder' ],
	'BannerLoader' => [ 'Banierlaojer' ],
	'BannerRandom' => [ 'Netzelde_welke_banier' ],
	'RecordImpression' => [ 'Weergave_vastelegen' ],
	'HideBanners' => [ 'Banier_verbargen' ],
];

/** Dutch (Nederlands) */
$specialPageAliases['nl'] = [
	'CentralNotice' => [ 'CentraleMededeling' ],
	'CentralNoticeLogs' => [ 'CentraleMededelingenlogboek' ],
	'NoticeTemplate' => [ 'Mededelingsjabloon' ],
	'GlobalAllocation' => [ 'GlobaleToewijzing' ],
	'BannerAllocation' => [ 'Bannertoewijzing' ],
	'BannerController' => [ 'Bannerbeheerder' ],
	'BannerLoader' => [ 'Bannerlader' ],
	'BannerRandom' => [ 'WillekeurigeBanner' ],
	'RecordImpression' => [ 'WeergaveVastleggen' ],
	'HideBanners' => [ 'BannersVerbergen' ],
];

/** Norwegian Nynorsk (norsk nynorsk) */
$specialPageAliases['nn'] = [
	'CentralNotice' => [ 'Sentralmerknad' ],
	'NoticeTemplate' => [ 'Merknadsmal' ],
];

/** Oriya (ଓଡ଼ିଆ) */
$specialPageAliases['or'] = [
	'CentralNotice' => [ 'ସୂଚନାଫଳକ' ],
	'CentralNoticeLogs' => [ 'ସୂଚନାଫଳକଲଗ' ],
	'NoticeTemplate' => [ 'ସୂଚନାଛାଞ୍ଚ' ],
];

/** Punjabi (ਪੰਜਾਬੀ) */
$specialPageAliases['pa'] = [
	'CentralNotice' => [ 'ਕੇਂਦਰੀ_ਨੋਟਿਸ' ],
	'CentralNoticeLogs' => [ 'ਕੇਂਦਰੀ_ਨੋਟਿਸ_ਚਿੱਠੇ' ],
	'HideBanners' => [ 'ਬੈਨਰ_ਲੁਕਾਓ' ],
];

/** Polish (polski) */
$specialPageAliases['pl'] = [
	'CentralNotice' => [ 'Globalny_komunikat' ],
	'NoticeTemplate' => [ 'Szablon_komunikatu' ],
];

/** Sicilian (sicilianu) */
$specialPageAliases['scn'] = [
	'CentralNotice' => [ 'AvvisoCentralizzato' ],
	'CentralNoticeLogs' => [ 'RegistriAvvisoCentralizzato' ],
	'NoticeTemplate' => [ 'TemplateAvviso' ],
	'BannerAllocation' => [ 'DestinazioneBanner' ],
	'BannerController' => [ 'ControllerBanner' ],
	'BannerLoader' => [ 'CaricatoreBanner' ],
	'HideBanners' => [ 'NascondiBanner' ],
];

/** Tagalog (Tagalog) */
$specialPageAliases['tl'] = [
	'CentralNotice' => [ 'Panggitnang_Pabatid' ],
	'CentralNoticeLogs' => [ 'Mga_Pagtatala_ng_Panggitnang_Pabatid' ],
	'NoticeTemplate' => [ 'Suleras_ng_Pabatid' ],
];

/** Turkish (Türkçe) */
$specialPageAliases['tr'] = [
	'CentralNotice' => [ 'MerkeziBildirim' ],
	'CentralNoticeLogs' => [ 'MerkeziBildirimGünlükleri' ],
	'NoticeTemplate' => [ 'BildirimŞablonu' ],
	'BannerAllocation' => [ 'AfişTahsisi' ],
	'BannerController' => [ 'AfişKontrolü', 'AfişKontrolAracı' ],
	'BannerLoader' => [ 'AfişYükleyici' ],
	'HideBanners' => [ 'AfişleriGizle', 'AfişGizle' ],
];

/** Ukrainian (українська) */
$specialPageAliases['uk'] = [
	'CentralNotice' => [ 'Загальне_оголошення' ],
];

/** Urdu (اردو) */
$specialPageAliases['ur'] = [
	'CentralNotice' => [ 'مرکزی_اعلان' ],
	'CentralNoticeBanners' => [ 'مرکزی_اعلان_کے_بینر' ],
	'CentralNoticeLogs' => [ 'مرکزی_اعلان_کے_نوشتے' ],
	'NoticeTemplate' => [ 'سانچہ_اعلان', 'نوٹس_سانچہ' ],
	'GlobalAllocation' => [ 'عالمی_تخصیص' ],
	'BannerAllocation' => [ 'تخصیص_بینر' ],
	'BannerController' => [ 'ناظم_بینر' ],
	'BannerLoader' => [ 'بینر_لوڈر' ],
	'BannerRandom' => [ 'جستہ_جست_ہبینر' ],
	'RecordImpression' => [ 'اندراج_تاثر' ],
	'HideBanners' => [ 'اخفائے_بینر' ],
];

/** Vietnamese (Tiếng Việt) */
$specialPageAliases['vi'] = [
	'CentralNotice' => [ 'Thông_báo_chung' ],
	'CentralNoticeBanners' => [ 'Bảng_thông_báo_chung' ],
	'CentralNoticeLogs' => [ 'Nhật_trình_thông_báo_chung' ],
	'NoticeTemplate' => [ 'Bản_mẫu_thông_báo' ],
	'GlobalAllocation' => [ 'Phân_phối_toàn_cục' ],
	'BannerAllocation' => [ 'Phân_bố_bảng' ],
	'BannerController' => [ 'Điều_khiển_bảng' ],
	'BannerLoader' => [ 'Tải_bảng' ],
	'BannerRandom' => [ 'Bảng_ngẫu_nhiên' ],
	'RecordImpression' => [ 'Ghi_lần_hiển_thị' ],
	'HideBanners' => [ 'Ẩn_bảng' ],
];

/** Simplified Chinese (中文（简体）‎) */
$specialPageAliases['zh-hans'] = [
	'CentralNotice' => [ '中心通告' ],
	'CentralNoticeBanners' => [ '中心通告横幅' ],
	'CentralNoticeLogs' => [ '中心通告日志' ],
	'NoticeTemplate' => [ '通告模板' ],
	'GlobalAllocation' => [ '全域分配' ],
	'BannerAllocation' => [ '横幅分配' ],
	'BannerController' => [ '横幅控制器' ],
	'BannerLoader' => [ '横幅装载器' ],
	'BannerRandom' => [ '随机横幅' ],
	'RecordImpression' => [ '记录印象' ],
	'HideBanners' => [ '隐藏横幅' ],
];

/** Traditional Chinese (中文（繁體）‎) */
$specialPageAliases['zh-hant'] = [
	'CentralNotice' => [ '中央公告' ],
	'CentralNoticeBanners' => [ '中央公告橫幅' ],
	'CentralNoticeLogs' => [ '中央公告日誌' ],
	'NoticeTemplate' => [ '公告模板' ],
	'GlobalAllocation' => [ '全域分配' ],
	'BannerAllocation' => [ '横幅分配' ],
	'BannerController' => [ '横幅控制器' ],
	'BannerLoader' => [ '橫幅讀取器' ],
	'BannerRandom' => [ '隨機橫幅' ],
	'RecordImpression' => [ '記錄印象' ],
	'HideBanners' => [ '隱藏橫幅' ],
];
